{{
********************************
* jvmMain - top object for JVM *
********************************
}}


CON
  'clock settings are selected jvmMainXXMHz
  commPort = 1 '0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN

  
OBJ
  comm:  "jvmComm"      'communication port object
  jd:    "jvmData"      'jvm memory access object
  nf:    "jvmNative"    'native functions
  je:    "jvmEngine"    'the bytecode interpreter
  jprog: "jvmJavaProg"  'storage area for java bytecodes (MUST ONLY BE INCLUDED HERE)

  
PUB main | c
{{ application starts here }}
  comm.start(commPort,true)
  comm.setReset
  repeat 'keep running
    nf.stop
    jd.init(jprog.getJavaProgram,jprog#JAVASIZE,commPort)  'initialize jvm registers and pass javaProg properties
    if comm.isReset
      comm.doReset
      comm.clearReset
      repeat
        c := comm.doDebug(2000)
      until c == -1
    else
      'mainloop
      nf.start                      'startup COGs for VP code
      repeat while NOT comm.isReset
        comm.doDebug(0)     'check for debug commands
        c := je.doBytecode 'execute next bytecode
        case c
          0..47: nf.doNative(c)  'invoke a native function
                 jd.incJvmPC(3)  'move to next bytcode
          'add userdefined native functions here
          
      